<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
use Magento\Framework\App\Action\Action;

?>
<?php
/**
 * Product list template
 *
 * @var $block \Magento\Catalog\Block\Product\ListProduct
 * @var \Magento\Framework\Escaper $escaper
 * @var \Magento\Framework\View\Helper\SecureHtmlRenderer $secureRenderer
 */
?>
<?php
$_productCollection = $block->getLoadedProductCollection();
/** @var \Magento\Catalog\Helper\Output $_helper */
$_helper = $this->helper(\Magento\Catalog\Helper\Output::class);
$cartIcon = '<svg xmlns="http://www.w3.org/2000/svg" class="minicart-icon-1" width="14" height="16" viewBox="0 0 14 16">
  <path d="M11,3V0H3V3H0V16H14V3H11ZM5,2H9V3H5V2Zm7,12H2V5H3V7H5V5H9V7h2V5h1v9Z"></path>
</svg>';
/** @var \Olegnax\Athlete2\Helper\ProductList $theme_helper */
$theme_helper = $this->helper(\Olegnax\Athlete2\Helper\ProductList::class);
$at_settings = $theme_helper->getModuleConfig();
$width = $at_settings[ 'product_images' ][ 'listing_image_width' ];
$height =  $at_settings[ 'product_images' ][ 'listing_image_height' ];

$showQuickview = $at_settings['products_listing']['quickview'] && $theme_helper->isActivePlugin( 'Olegnax_Quickview' );
$showOutofstock = $at_settings['products_listing']['outofstock'];
$showRating = $at_settings['products_listing']['rating'];
$showPrice = $at_settings['products_listing']['price'];
$showCart = $at_settings['products_listing']['add_to_cart'];
$showCartList = $at_settings['products_listing']['add_to_cart_list'];
$showWishlist = $at_settings['products_listing']['wishlist'];
$showCompare = $at_settings['products_listing']['compare'];
$showCategory = $at_settings['products_listing']['category_name'];
$showBrand = $at_settings['products_listing']['brand'];
$showReviewCount = $at_settings['products_listing']['review_count'];
$alignDetailsCenter = $at_settings['products_listing']['products_layout_centered'];
$quickviewPosition = $at_settings['products_listing']['quickview_position'];
$preloaderEnabled= $at_settings['products_listing']['preloader_enabled'];
$preloaderClasses = $preloaderEnabled ? 'lazy-loader' : '';
if($showBrand){
	$brandImageSize ='';
	$altBrandImage = !$at_settings['products_listing']['brand_image_alt'];
	$brandImageWidth = $at_settings['products_listing']['brand_image_width'];
	$brandImageHeight = $at_settings['products_listing']['brand_image_height'] ?: $at_settings['products_listing']['brand_image_width'];
	if($brandImageWidth && $brandImageHeight) {
		$brandImageSize = [$brandImageWidth, $brandImageHeight];
	}
}

$classes = [];
$classes[] = 'product-columns-' . $at_settings['products_listing']['grid_columns'];
$classes[] = 'product-columns-s-' . $at_settings['products_listing']['grid_columns_s'];
$classes[] = 'product-columns-m-' . $at_settings['products_listing']['grid_columns_m'];
$classes[] = 'product-columns-l-' . $at_settings['products_listing']['grid_columns_l'];
$classes[] = $alignDetailsCenter ? 'align-details-center' : '';
$classes[] = $showReviewCount ? 'show-review-count' : '';
$classes[] = $quickviewPosition ? ('quickview-' . $quickviewPosition) : '';
?>
<?php if (!$_productCollection->count()) :?>
	<div class="message info empty">
		<div><?= $escaper->escapeHtml(__('We can\'t find products matching the selection.')) ?></div>
	</div>
<?php else :?>
    <?= $block->getToolbarHtml() ?>
    <?= $block->getAdditionalHtml() ?>
    <?php
    if ($block->getMode() == 'grid') {
        $viewMode = 'grid';
        $imageDisplayArea = 'category_page_grid';
        $image_hover = 'category_page_grid_hover';
        $showDescription = $at_settings['products_listing']['description_on_grid'] ?: false;
		$showAvailability = false;
        $templateType = \Magento\Catalog\Block\Product\ReviewRendererInterface::SHORT_VIEW;
    } else {
        $viewMode = 'list';
        $imageDisplayArea = 'category_page_list';
        $image_hover = 'category_page_grid_hover';
        $showDescription = true;
		$showAvailability = true;
        $templateType = \Magento\Catalog\Block\Product\ReviewRendererInterface::FULL_VIEW;
    }
    /**
     * Position for actions regarding image size changing in vde if needed
     */
    $pos = $block->getPositioned();
    ?>
    <div class="products products-grid__layout-default wrapper <?= $escaper->escapeHtmlAttr( $viewMode. ' ' . implode( ' ', $classes )) ?> products-<?=  $escaper->escapeHtmlAttr( $viewMode ) ?>">
        <?php $iterator = 1; ?>
        <ol class="products list items product-items">
            <?php /** @var $_product \Magento\Catalog\Model\Product */ ?>
            <?php foreach ($_productCollection as $_product) :?>
				<?php $_productNameStripped = $block->stripTags($_product->getName(), null, true); ?>
                <?= /* @escapeNotVerified */ ($iterator++ == 1) ? '<li class="item product product-item">' : '</li><li class="item product product-item">' ?>
				<div class="product-item-info"
					 id="product-item-info_<?= /* @noEscape */ $_product->getId() ?>"
					 data-container="product-grid">
                    <?php
                    $productImage = $this->helper(\Olegnax\Athlete2\Helper\ProductImage::class)->getResizedImageHover($_product, $imageDisplayArea, $image_hover, [$width, $height]);
                    if ($pos != null) {
                        $position = 'left:' . $productImage->getWidth() . 'px;'
                            . 'top:' . $productImage->getHeight() . 'px;';
                    }
					?>
                    <?php // Product Image ?>
					<?php if ($viewMode == 'grid' ){ ?>
						<div class="product-grid__image-wrapper">
						<a href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>" class="product photo product-item-photo <?= $preloaderClasses ?>" tabindex="-1">
							<?= $productImage->toHtml() ?>
						</a>
							<?php if ($showWishlist || $showCompare || $showCart || $showQuickview): ?>
								<div class="product-item-inner">
									<div class="product actions product-item-actions">
										<div class="actions-primary">
											<?php if ($_product->isSaleable()): ?>
												<?php if ($showCart): ?>
													<?php $postParams = $block->getAddToCartPostParams($_product); ?>
													<form data-role="tocart-form"
														  data-product-sku="<?= $escaper->escapeHtml($_product->getSku()) ?>"
														  action="<?= $escaper->escapeUrl($postParams['action']) ?>"
														  method="post">
                                                        <?php $optionsData = $block->getData('viewModel')->getOptionsData($_product); ?>
                                                        <?php foreach ($optionsData as $optionItem): ?>
															<input type="hidden"
																   name="<?= $escaper->escapeHtml($optionItem['name']) ?>"
																   value="<?= $escaper->escapeHtml($optionItem['value']) ?>">
                                                        <?php endforeach; ?>
														<input type="hidden"
															   name="product"
															   value="<?= /* @noEscape */ $postParams['data']['product'] ?>">
														<input type="hidden"
															   name="<?= /* @noEscape */ Action::PARAM_NAME_URL_ENCODED ?>"
															   value="<?=
                                                               /* @noEscape */ $postParams['data'][Action::PARAM_NAME_URL_ENCODED]
                                                               ?>">
														<?= $block->getBlockHtml('formkey') ?>
														<button type="submit"
																title="<?= $escaper->escapeHtmlAttr(__('Add to Cart')) ?>"
																class="action tocart primary">
															<?= $cartIcon ?><span><?= $escaper->escapeHtml(__('Add to Cart')) ?></span>
														</button>
													</form>
												<?php endif; ?>
											<?php else :?>
												<?php if (!$_product->isAvailable() && $showOutofstock) :?>
													<div class="stock unavailable"><span><?= $escaper->escapeHtml(__('Out of stock')) ?></span></div>
												<?php endif; ?>
											<?php endif; ?>
											<?php if ($showWishlist || $showCompare): ?>
												<div data-role="add-to-links" class="actions-secondary">
                                                    <?php if ($addToBlock = $block->getChildBlock('addto')):?>
                                                        <?= $addToBlock->setProduct($_product)->getChildHtml() ?>
                                                    <?php endif; ?>
												</div>
                                                <?= ($pos && strpos($pos, $viewMode . '-secondary')) ?
                                                    /* @noEscape */ $secureRenderer->renderStyleAsTag(
                                                        $position,
                                                        'product-item-info_' . $_product->getId() . ' div.actions-secondary'
                                                    ) : '' ?>
										  <?php endif; ?>
										</div>
                                        <?= ($pos && strpos($pos, $viewMode . '-primary')) ?
                                            /* @noEscape */ $secureRenderer->renderStyleAsTag(
                                                $position,
                                                'product-item-info_' . $_product->getId() . ' div.actions-primary'
                                            ) : '' ?>
										<?php
										if ( $showQuickview ) {
											echo $this->helper( 'Olegnax\Quickview\Helper\Helper' )->getButton( $_product, 'button quick-view' );
										}
										?>
									</div>
									<a href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>" title="<?= /* @noEscape */ $_productNameStripped ?>" aria-label="View Product" class="overlay-link"><?= /* @noEscape */ $_productNameStripped ?></a>
								</div>
							<?php endif; ?>
							<?php if ( $theme_helper->isActivePlugin( 'Olegnax_ProductLabel' ) ) {
								echo $this->helper( 'Olegnax\ProductLabel\Helper\Helper' )->showLabels( $_product );
							}  ?>
						</div>
						<div class="product-grid-overlay"></div>

						<div class="product details product-item-details">
                            <?php if ( $showBrand && $theme_helper->isActivePlugin( 'Olegnax_BrandSlider' ) ) {
                                echo $this->helper( 'Olegnax\BrandSlider\Helper\Helper' )->getProductBrandImage( $_product, $altBrandImage, $brandImageSize );
                            }?>
							<?php if ( $showCategory && $category = $theme_helper->getLastCategory( $_product ) ) : ?>
							<div class="ox-product-grid__categories">
								<a href="<?= $escaper->escapeUrl($category->getUrl()); ?>" class="ox-product-grid__category-link"><?= $escaper->escapeHtml($category->getName()); ?></a>
							</div>
							<?php endif; ?>
							<strong class="product name product-item-name">
								<a class="product-item-link"
								   href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>">
									<?= /* @noEscape */ $_helper->productAttribute($_product, $_product->getName(), 'name') ?>
								</a>
							</strong>

							<?php if ( $showPrice ) { echo /* @noEscape */ $block->getProductPrice($_product); } ?>
                            <?= $block->getProductDetailsHtml($_product) ?>
							<?php if ($showDescription):?>
								<div class="product description product-item-description">
									<?= /* @noEscape */ $_helper->productAttribute($_product, $_product->getShortDescription(), 'short_description') ?>
                                    <a href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>"
                                       title="<?= /* @noEscape */ $_productNameStripped ?>"
                                       class="action more"><?= $escaper->escapeHtml(__('Learn More')) ?></a>
								</div>
							<?php endif; ?>

							<?php if ( !$_product->isSaleable() && $showAvailability ): ?>
								<?php if ($_product->isAvailable()): ?>
									<div class="stock available"><span><?= $escaper->escapeHtml(__('In stock')) ?></span></div>
								<?php else: ?>
									<div class="stock unavailable"><span><?= $escaper->escapeHtml(__('Out of stock')) ?></span></div>
								<?php endif; ?>
							<?php endif; ?>

							<?php if ( $showRating ){ echo $block->getReviewsSummaryHtml($_product, $templateType); } ?>
						</div>
					<?php } ?>


					<?php if ($viewMode == 'list' ): ?>

						<div class="product-grid__image-wrapper">
							<a href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>" class="product photo product-item-photo <?= $preloaderClasses ?>" tabindex="-1">
								<?= $productImage->toHtml() ?>
							</a>
							<?php if ( $theme_helper->isActivePlugin( 'Olegnax_ProductLabel' ) ) {
								echo $this->helper( 'Olegnax\ProductLabel\Helper\Helper' )->showLabels( $_product );
							}  ?>
						</div>

						<div class="product details product-item-details">
                           <?php if ( $showBrand && $theme_helper->isActivePlugin( 'Olegnax_BrandSlider' ) ) {
                                echo $this->helper( 'Olegnax\BrandSlider\Helper\Helper' )->getProductBrandImage( $_product, $altBrandImage, $brandImageSize );
                            }?>
							<?php if ( $showCategory && $category = $theme_helper->getLastCategory( $_product ) ) : ?>
							<div class="ox-product-grid__categories"><a href="<?= $category->getUrl(); ?>" class="ox-product-grid__category-link"><?= $category->getName(); ?></a></div>
							<?php endif; ?>
							<?php
								$_productNameStripped = $block->stripTags($_product->getName(), null, true);
							?>
							<strong class="product name product-item-name">
								<a class="product-item-link"
								   href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>">
									<?= /* @noEscape */ $_helper->productAttribute($_product, $_product->getName(), 'name') ?>
								</a>
							</strong>

							<?php if ( $showRating ){ echo $block->getReviewsSummaryHtml($_product, $templateType); } ?>

                            <?php if ($_product->isAvailable()) :?>
                                <?= $block->getProductDetailsHtml($_product) ?>
                            <?php endif; ?>
                            <?php $descContent = $_helper->productAttribute($_product, $_product->getShortDescription(), 'short_description') ?>
                            <?php if ($showDescription && !empty($descContent)):?>
								<div class="product description product-item-description">
                                    <?= /* @noEscape */ $descContent ?>
									<a href="<?= $escaper->escapeUrl($_product->getProductUrl()) ?>"
									   title="<?= /* @noEscape */ $_productNameStripped ?>"
									   class="action more"><?= $escaper->escapeHtml(__('Learn More')) ?></a>
								</div>
                            <?php endif; ?>
						</div>

						<div class="product-list-view__right-wrapper">

							<?php if ( $showPrice ) { echo /* @noEscape */ $block->getProductPrice($_product); } ?>

							<?php if ( !$_product->isSaleable() && $showAvailability ): ?>
								<?php if ($_product->isAvailable()): ?>
									<div class="stock available"><span><?= $escaper->escapeHtml(__('In stock')) ?></span></div>
								<?php else: ?>
									<div class="stock unavailable"><span><?= $escaper->escapeHtml(__('Out of stock')) ?></span></div>
								<?php endif; ?>
							<?php endif; ?>

							<?php if ($showCartList): ?>
								<div class="product-item-inner">
									<div class="product actions product-item-actions">
										<div class="actions-primary">
											<?php if ($_product->isSaleable()): ?>
												<?php $postParams = $block->getAddToCartPostParams($_product); ?>
												<form data-role="tocart-form"
													  data-product-sku="<?= $escaper->escapeHtml($_product->getSku()) ?>"
													  action="<?= $escaper->escapeUrl($postParams['action']) ?>"
													  method="post">
													<?php $optionsData = $block->getData('viewModel')->getOptionsData($_product); ?>
                                                    <?php foreach ($optionsData as $optionItem): ?>
														<input type="hidden"
															   name="<?= $escaper->escapeHtml($optionItem['name']) ?>"
															   value="<?= $escaper->escapeHtml($optionItem['value']) ?>">
                                                    <?php endforeach; ?>
													<input type="hidden"
														   name="product"
														   value="<?= /* @noEscape */ $postParams['data']['product'] ?>">
													<input type="hidden"
														   name="<?= /* @noEscape */ Action::PARAM_NAME_URL_ENCODED ?>"
														   value="<?=
                                                           /* @noEscape */ $postParams['data'][Action::PARAM_NAME_URL_ENCODED]
                                                           ?>">
													<?= $block->getBlockHtml('formkey') ?>
													<button type="submit"
															title="<?= $escaper->escapeHtmlAttr(__('Add to Cart')) ?>"
															class="action tocart primary"
                                                            disabled>
														<?= $cartIcon ?><span><?= $escaper->escapeHtml(__('Add to Cart')) ?></span>
													</button>
												</form>
											<?php endif; ?>
										</div>
                                        <?= ($pos && strpos($pos, $viewMode . '-primary')) ?
                                            /* @noEscape */ $secureRenderer->renderStyleAsTag(
                                                $position,
                                                'product-item-info_' . $_product->getId() . ' div.actions-primary'
                                            ) : '' ?>
									</div>
								</div>
							<?php endif; ?>

							<?php if ($showWishlist || $showCompare): ?>
								<div data-role="add-to-links" class="actions-secondary">
                                    <?php if ($addToBlock = $block->getChildBlock('addto')):?>
                                        <?= $addToBlock->setProduct($_product)->getChildHtml() ?>
                                    <?php endif; ?>
								</div>
                                <?= ($pos && strpos($pos, $viewMode . '-secondary')) ?
                                    /* @noEscape */ $secureRenderer->renderStyleAsTag(
                                        $position,
                                        'product-item-info_' . $_product->getId() . ' div.actions-secondary'
                                    ) : '' ?>
							<?php endif; ?>

						</div>
					<?php endif; ?>
                </div>
                <?= ($pos && strpos($pos, $viewMode . '-actions')) ?
                    /* @noEscape */ $secureRenderer->renderStyleAsTag(
                        $position,
                        'product-item-info_' . $_product->getId() . ' div.product-item-actions'
                    ) : '' ?>
                <?= ($iterator == count($_productCollection)+1) ? '</li>' : '' ?>
            <?php endforeach; ?>
        </ol>
    </div>
    <?= $block->getChildBlock('toolbar')->setIsBottom(true)->toHtml() ?>
	<script type="text/x-magento-init">
	{
		"[data-role=tocart-form], .form.map.checkout": {
			"catalogAddToCart": {
				"product_sku": "<?= $escaper->escapeJs($_product->getSku()) ?>"
			}
		}
	}
	</script>
<?php endif; ?>
